明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1504|回复: 2

[VBA]请斑竹看看,有何问题?

[复制链接]
发表于 2003-11-11 14:56:00 | 显示全部楼层 |阅读模式
Public Sub test2()
Dim mypline As AcadLWPolyline
Dim ss1 As AcadSelectionSet
Dim pt As Variant
Dim points As Variant
Call ThisDrawing.Utility.GetEntity(mypline, pt, "22=")
Call bulidselction(ss1, 1) '创建选择集
points = mypline.Coordinates
ss1.SelectByPolygon acSelectionSetCrossingPolygon, points
Debug.Print ss1.count
End Sub



Public Sub bulidselction(mysle As AcadSelectionSet, pp As String)
              '定义名为PP的选择集,赋值于mysle,若存在则引用,不存在则创建
    Dim k As Integer
    Dim num As Integer
    Dim aaa As Boolean
    aaa = False
            For k = 0 To ThisDrawing.SelectionSets.count - 1
                If ThisDrawing.SelectionSets.Item(k).Name = pp Then
                aaa = True
                num = k
                Exit For
                End If
            Next k
            If aaa = True Then
                Set mysle = ThisDrawing.SelectionSets.Item(pp)
                mysle.Delete
                Set mysle = ThisDrawing.SelectionSets.add(pp)
            Else
                Set mysle = ThisDrawing.SelectionSets.add(pp)
            End If
End Sub



该段程序为何无法执行
发表于 2003-11-11 19:35:00 | 显示全部楼层
1.创建选择集的函数也太复杂了一点吧,其实几句就可以完成的,查查以前的贴子吧。
2.优化多段线的点集是二维的,而选择集的点指需要的是三维坐标的,所以出错。

  1. Public Sub test2()
  2. Dim mypline As AcadLWPolyline
  3. Dim ss1 As AcadSelectionSet
  4. Dim pt As Variant
  5. Dim points As Variant
  6. Call ThisDrawing.Utility.GetEntity(mypline, pt, "22=")
  7. Call bulidselction(ss1, 1) '创建选择集
  8. points = mypline.Coordinates
  9. Dim pnts() As Double
  10. Dim i As Integer
  11. i = (UBound(points) + 1) / 2 * 3 - 1
  12. ReDim pnts(i)
  13. For i = 0 To (UBound(points) + 1) / 2 - 1
  14.     pnts(i * 2 + i) = points(i * 2)
  15.     pnts(i * 2 + i + 1) = points(i * 2 + 1)
  16. Next
  17. ss1.SelectByPolygon acSelectionSetCrossingPolygon, pnts
  18. Debug.Print ss1.Count
  19. End Sub
 楼主| 发表于 2003-11-12 09:41:00 | 显示全部楼层
问题解决
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-28 13:47 , Processed in 0.151373 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表